/*
 *
 * Copyright (C) 2012 Francisco Madrigal
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

extern "C"
void CUDA_Dx(float *ImageDx_dev,uchar *Image_dev,int N,int imageW,dim3 grid,dim3 threads);

extern "C"
void CUDA_Dy(float *ImageDy_dev,uchar *Image_dev,int N,int imageW,dim3 grid,dim3 threads);

extern "C"
void CUDA_MG(float *ImageMG_dev,float *ImageDx_dev,float *ImageDy_dev,int N,dim3 grid,dim3 threads);

extern "C"
void CUDA_MatMultPoint(float *ImageDst_dev,float *Image1_dev,float *Image2_dev,int N,dim3 grid,dim3 threads);

extern "C"
void CUDA_Harris1(float *ImageDst_dev,float *ImageD2x_dev,float *ImageD2y_dev,float *ImageDxy_dev,int N, float k,dim3 grid,dim3 threads);

extern "C"
void CUDA_Harris(float *ImageDst_dev,float *ImageDx_dev,float *ImageDy_dev, int N, float k, dim3 grid, dim3 threads);

extern "C"
void CUDA_Harris_window(float *ImageDst_dev,float *ImageDx_dev,float *ImageDy_dev, int imageW,int imageH,int window, float k, dim3 grid, dim3 threads);

extern "C"
void CUDA_Threshold(float *ImageDst_dev,float *ImageSrc_dev, float thrhld, int N, dim3 grid, dim3 threads);

extern "C"
void CUDA_GaussianFilter(uchar4 *Image_dev,int imageW,int imageH,dim3 grid,dim3 threads);

extern "C"
void CUDA_CreateMemoryArray(int imageW,int imageH);

extern "C"
void CUDA_FreeArrays();
